function love.load()
	love.graphics.setCaption("Puckman")
	love.graphics.setMode(650, 650, false, true, 4)
	image = love.graphics.newImage("Snizake.tga")
	love.graphics.setIcon(image)
	love.graphics.setBackgroundColor(230,230,230)
	
	fontusdallas = love.graphics.newFont("ussdallas.ttf", 15)
	love.graphics.setFont(fontusdallas)
	
	--Set Random Seed
	math.randomseed(os.time());
	--caricamento mappe
	local ok, chunk, result
	ok, chunk = pcall( love.filesystem.load, "mappa1.lua" ) -- load the chunk safely
	if not ok then
		print('Errore durante l\'apertura della mappa: ' .. tostring(chunk))
	else
		ok, result = pcall(chunk) -- execute the chunk safely
		if not ok then -- will be false if there is an error
			print('Errore durante il caricamento della mappa: ' .. tostring(result))
		else
			--mappa caricata con successo!
			mappa = result.mappa
			player = result.player
			ghosts = result.ghosts
			speeds = result.speeds
		end
	end
	windoww = love.graphics.getHeight( )
	windowh = love.graphics.getWidth( )
	gridw = table.getn( mappa )
	if gridw ~= 0 then
		gridh = table.getn( mappa[1] )
	end
	
	started = false
	gameover = false
	basespeed = 30 --caselle/secondo * 100
	--speed
	dotcounter = 0
	oldscore = 0
	score = 0
	globaldotcounter = 0
	globaldotcounterenabled = false
	lasteatendot = 0
	ghosteatencount = 1
	deathtimer = 0
	victory = false
	fruitcount = 0
	fruittimer = 0
	freedelroy = true

end

function love.draw()
	--draw blocks
	for i = 1, gridw do
		for k = 1, gridh do
			if mappa[i][k] == 1 then
				love.graphics.setColor(0, 0, 64)
				love.graphics.rectangle( "fill", (windoww / gridw) * (i - 1), (windowh / gridh) * (k - 1), (windoww / gridw), (windowh / gridh))
			end
		end
	end

	--draw dots
	for i = 1, gridw do
		for k = 1, gridh do
			if mappa[i][k] == 4 then
				love.graphics.setColor(70, 70, 200)
				love.graphics.circle( "fill", (windoww / gridw) * (i - 1) + (windoww / gridw) / 2, (windowh / gridh) * (k - 1) + (windowh / gridh) / 2, 4, 16)

			end
		end
	end

	--draw power pellets
	for i = 1, gridw do
		for k = 1, gridh do
			if mappa[i][k] == 5 then
				love.graphics.setColor(70, 70, 200)
				love.graphics.circle( "fill", (windoww / gridw) * (i - 1) + (windoww / gridw) / 2, (windowh / gridh) * (k - 1) + (windowh / gridh) / 2, 7, 16)

			end
		end
	end

	--draw fruit
	if (fruittimer > 0) then
		love.graphics.setColor(245, 0, 61)
		love.graphics.circle( "fill", (windoww / gridw) * (15), (windowh / gridh) * (20) + (windowh / gridh) / 2, 7, 16)
	end

	--draw puck
	love.graphics.setColor(110, 110, 110)
	love.graphics.circle( "fill", (windoww / gridw) * (player.x - 1) + (windoww / gridw) * player.partialx / 32, (windowh / gridh) * (player.y - 1) + (windowh / gridh) * player.partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2, 16)
	love.graphics.setColor(200, 200, 0)
	love.graphics.circle( "fill", (windoww / gridw) * (player.x - 1) + (windoww / gridw) * player.partialx / 32, (windowh / gridh) * (player.y - 1) + (windowh / gridh) * player.partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2 - 1, 16)

	--disegna i passaggi nel tunnel da entrambe le parti
	if (player.x == 1) then
		love.graphics.setColor(110, 110, 110)
		love.graphics.circle( "fill", (windoww / gridw) * (gridw) + (windoww / gridw) * player.partialx / 32, (windowh / gridh) * (player.y - 1) + (windowh / gridh) * player.partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2, 16)
		love.graphics.setColor(200, 200, 0)
		love.graphics.circle( "fill", (windoww / gridw) * (gridw) + (windoww / gridw) * player.partialx / 32, (windowh / gridh) * (player.y - 1) + (windowh / gridh) * player.partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2 - 1, 16)
	end

	if (player.x == gridw) then
		love.graphics.setColor(110, 110, 110)
		love.graphics.circle( "fill", (windoww / gridw) * (-1) + (windoww / gridw) * player.partialx / 32, (windowh / gridh) * (player.y - 1) + (windowh / gridh) * player.partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2, 16)
		love.graphics.setColor(200, 200, 0)
		love.graphics.circle( "fill", (windoww / gridw) * (-1) + (windoww / gridw) * player.partialx / 32, (windowh / gridh) * (player.y - 1) + (windowh / gridh) * player.partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2 - 1, 16)
	end

	--draw ghosts
	if ((ghosts ~= nil) and (table.getn(ghosts) ~= 0)) then
		for i=1,table.getn(ghosts) do
			love.graphics.setColor(110, 110, 110)
			love.graphics.circle( "fill", (windoww / gridw) * (ghosts[i].x - 1) + (windoww / gridw) * ghosts[i].partialx / 32, (windowh / gridh) * (ghosts[i].y - 1) + (windowh / gridh) * ghosts[i].partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2, 16)
			if (ghosts[i].mode == 3) then
				love.graphics.setColor(230, 230, 230) --eyed
			elseif (ghosts[i].mode == 2) then
				love.graphics.setColor(30, 115, 200) --frightened
			elseif ((ghosts[i].gtype == 0) or (ghosts[i].gtype == 4) or (ghosts[i].gtype == 5)) then
				love.graphics.setColor(200, 0, 0) --blinky
			elseif (ghosts[i].gtype == 1) then
				love.graphics.setColor(255, 200, 255) --pinky
			elseif (ghosts[i].gtype == 2) then
				love.graphics.setColor(100, 255, 255) --inky
			elseif (ghosts[i].gtype == 3) then
				love.graphics.setColor(255, 177, 61) --clyde
			end
			love.graphics.circle( "fill", (windoww / gridw) * (ghosts[i].x - 1) + (windoww / gridw) * ghosts[i].partialx / 32, (windowh / gridh) * (ghosts[i].y - 1) + (windowh / gridh) * ghosts[i].partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2 - 1, 16)

			--disegna i passaggi nei tunnel
			if (ghosts[i].x == 1) then
				love.graphics.setColor(110, 110, 110)
				love.graphics.circle( "fill", (windoww / gridw) * (gridw) + (windoww / gridw) * ghosts[i].partialx / 32, (windowh / gridh) * (ghosts[i].y - 1) + (windowh / gridh) * ghosts[i].partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2, 16)
				if (ghosts[i].mode == 3) then
					love.graphics.setColor(230, 230, 230) --eyed
				elseif (ghosts[i].mode == 2) then
					love.graphics.setColor(30, 115, 200) --frightened
				elseif ((ghosts[i].gtype == 0) or (ghosts[i].gtype == 4) or (ghosts[i].gtype == 5)) then
					love.graphics.setColor(200, 0, 0) --blinky
				elseif (ghosts[i].gtype == 1) then
					love.graphics.setColor(255, 200, 255) --pinky
				elseif (ghosts[i].gtype == 2) then
					love.graphics.setColor(100, 255, 255) --inky
				elseif (ghosts[i].gtype == 3) then
					love.graphics.setColor(255, 177, 61) --clyde
				end
				love.graphics.circle( "fill", (windoww / gridw) * (gridw) + (windoww / gridw) * ghosts[i].partialx / 32, (windowh / gridh) * (ghosts[i].y - 1) + (windowh / gridh) * ghosts[i].partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2 - 1, 16)
			end

			if (ghosts[i].x == gridw) then
				love.graphics.setColor(110, 110, 110)
				love.graphics.circle( "fill", (windoww / gridw) * (-1) + (windoww / gridw) * ghosts[i].partialx / 32, (windowh / gridh) * (ghosts[i].y - 1) + (windowh / gridh) * ghosts[i].partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2, 16)
				if (ghosts[i].mode == 3) then
					love.graphics.setColor(230, 230, 230) --eyed
				elseif (ghosts[i].mode == 2) then
					love.graphics.setColor(30, 115, 200) --frightened
				elseif ((ghosts[i].gtype == 0) or (ghosts[i].gtype == 4) or (ghosts[i].gtype == 5)) then
					love.graphics.setColor(200, 0, 0) --blinky
				elseif (ghosts[i].gtype == 1) then
					love.graphics.setColor(255, 200, 255) --pinky
				elseif (ghosts[i].gtype == 2) then
					love.graphics.setColor(100, 255, 255) --inky
				elseif (ghosts[i].gtype == 3) then
					love.graphics.setColor(255, 177, 61) --clyde
				end
				love.graphics.circle( "fill", (windoww / gridw) * (-1) + (windoww / gridw) * ghosts[i].partialx / 32, (windowh / gridh) * (ghosts[i].y - 1) + (windowh / gridh) * ghosts[i].partialy / 32, math.min((windoww / gridw), (windowh / gridh)) / 2 - 1, 16)
			end
		end
	end

	--print debug strings
	if (debugtext ~= nil) then
		love.graphics.setColor(110,110,110)
		love.graphics.printf(debugtext, windoww/4, windowh/2 - 30,650/2,"center")
	end

	--print score
	love.graphics.setColor(110,110,110)
	love.graphics.printf(score, (windoww / gridw) * 5, (windowh / gridh), windoww - ((windoww / gridw) * 5), "left")

	--draw lives
	if (player.lives > 1) then
		for i=1,player.lives - 1 do
			love.graphics.setColor(110, 110, 110)
			love.graphics.circle( "fill", (windoww / gridw) * (1 + i * 2), (windowh / gridh) * 35, math.min((windoww / gridw), (windowh / gridh)) / 1.3, 16)
			love.graphics.setColor(200, 200, 0)
			love.graphics.circle( "fill", (windoww / gridw) * (1 + i * 2), (windowh / gridh) * 35, math.min((windoww / gridw), (windowh / gridh)) / 1.3 - 1, 16)
		end
	end

	--draw fruits
	if (fruitcount > 0) then
		for i=1, fruitcount do
			love.graphics.setColor(245, 0, 61)
			love.graphics.circle( "fill", (windoww / gridw) * (23 + i * 2), (windowh / gridh) * 35, 9, 16)
		end
	end

	--print gameover
	if (gameover == true) then
		love.graphics.setColor(110,110,110)
		love.graphics.printf("GAME OVER", windoww/4, windowh/2 - 30,650/2,"center")
	end

	--print victory
	if (victory == true) then
		love.graphics.setColor(110,110,110)
		love.graphics.printf("VICTORY", windoww/4, windowh/2 - 30,650/2,"center")
	end
end

function love.update(dt)
	if ((score >= 10000) and (oldscore < 10000)) then
		player.lives = player.lives + 1
	end
	oldscore = score
	if (deathtimer >= 0) then
		deathtimer = deathtimer - (dt * 1000)
		if (deathtimer <= 0) then
			reposition()
		end
	end
	if (dotcounter >= 244) then
		victory = true
	end
	if (fruittimer > 0) then
		fruittimer = fruittimer - (dt * 1000)
	end
	if ((gameover == false) and (started == true) and (victory == false)) then
		--world:update(dt)
		if ((love.keyboard.isDown("up")) and (mappa[player.x][player.y - 1] ~= 1) and (mappa[player.x][player.y - 1] ~= 3)) then
		  player.direction = 0
		  player.stopped = false
		end
		if ((love.keyboard.isDown("left")) and ((player.x == 1) or ((mappa[player.x - 1][player.y] ~= 1) and (mappa[player.x - 1][player.y] ~= 3)))) then
		  player.direction = 1
		  player.stopped = false
		end
		if ((love.keyboard.isDown("down")) and (mappa[player.x][player.y + 1] ~= 1) and (mappa[player.x][player.y + 1] ~= 3)) then
		  player.direction = 2
		  player.stopped = false
		end
		if ((love.keyboard.isDown("right")) and ((player.x == gridw) or ((mappa[player.x + 1][player.y] ~= 1) and (mappa[player.x + 1][player.y] ~= 1)))) then
		  player.direction = 3
		  player.stopped = false
		end

		if (preferredjailghost() ~= nil) then
			lasteatendot = lasteatendot + dt * 1000
		end

		--move player
		if (player.stopped == false) then
			eatghosts(player.x, player.y)
			if (player.frightenedtime > 0) then
				if ((player.lasteatendotx == player.x) and (player.lasteatendoty == player.y)) then
					movement = ((dt/10) * basespeed * 32) * (speeds.frightplayerdot / 100)
				else
					movement = ((dt/10) * basespeed * 32) * (speeds.frightplayer / 100)
				end
			else
				if ((player.lasteatendotx == player.x) and (player.lasteatendoty == player.y)) then
					movement = ((dt/10) * basespeed * 32) * (speeds.playerdot / 100)
				else
					movement = ((dt/10) * basespeed * 32) * (speeds.player / 100)
				end
			end
			if (player.direction == 0) then
				if ((mappa[player.x][player.y - 1] ~= 1) or (player.partialy > (32/2))) then
					player.partialy = player.partialy - movement
					if (player.partialy < 0) then
						player.y = player.y - 1
						player.partialy = player.partialy + 31
					end
					if (player.partialx ~= (32/2)) then
						if (player.partialx < (32/2)) then
							player.partialx = player.partialx + movement
							if (player.partialx > (32/2)) then
								player.partialx = (32/2)
							end
						else
							player.partialx = player.partialx - movement
							if (player.partialx < (32/2)) then
								player.partialx = (32/2)
							end
						end
					end
				else
					player.stopped = true
					if (player.partialy < (32/2)) then
						player.partialy = (32/2)
					end
				end
			elseif (player.direction == 1) then
				if ((player.x == 1) or (mappa[player.x - 1][player.y] ~= 1) or (player.partialx > (32/2))) then
					player.partialx = player.partialx - movement
					if (player.partialx < 0) then
						player.x = player.x - 1
						if (player.x == 0) then
							player.x = gridw
						end
						player.partialx = player.partialx + 31
					end
					if (player.partialy ~= (32/2)) then
						if (player.partialy < (32/2)) then
							player.partialy = player.partialy + movement
							if (player.partialy > (32/2)) then
								player.partialy = (32/2)
							end
						else
							player.partialy = player.partialy - movement
							if (player.partialy < (32/2)) then
								player.partialy = (32/2)
							end
						end
					end
				else
					player.stopped = true
					if (player.partialx < (32/2)) then
						player.partialx = (32/2)
					end
				end
			elseif (player.direction == 2) then
				if ((mappa[player.x][player.y + 1] ~= 1) or (player.partialy < (32/2))) then
					player.partialy = player.partialy + movement
					if (player.partialy >= 32) then
						player.y = player.y + 1
						player.partialy = player.partialy - 31
					end
					if (player.partialx ~= (32/2)) then
						if (player.partialx < (32/2)) then
							player.partialx = player.partialx + movement
							if (player.partialx > (32/2)) then
								player.partialx = (32/2)
							end
						else
							player.partialx = player.partialx - movement
							if (player.partialx < (32/2)) then
								player.partialx = (32/2)
							end
						end
					end
				else
					player.stopped = true
					if (player.partialy > (32/2)) then
						player.partialy = (32/2)
					end
				end
			elseif (player.direction == 3) then
				if ((player.x == gridw) or (mappa[player.x + 1][player.y] ~= 1) or (player.partialx < (32/2))) then
					player.partialx = player.partialx + movement
					if (player.partialx >= 32) then
						player.x = player.x + 1
						if (player.x == gridw + 1) then
							player.x = 1
						end
						player.partialx = player.partialx - 31
					end
					if (player.partialy ~= (32/2)) then
						if (player.partialy < (32/2)) then
							player.partialy = player.partialy + movement
							if (player.partialy > (32/2)) then
								player.partialy = (32/2)
							end
						else
							player.partialy = player.partialy - movement
							if (player.partialy < (32/2)) then
								player.partialy = (32/2)
							end
						end
					end
				else
					player.stopped = true
					if (player.partialx > (32/2)) then
						player.partialx = (32/2)
					end
				end
			end
		end
		if (player.frightenedtime > 0) then
			player.frightenedtime = player.frightenedtime - dt * 1000
		end

		--move ghosts
		if ((ghosts ~= nil) and (table.getn(ghosts) ~= 0)) then
			if ((globaldotcounterenabled == false) and (preferredjailghost() ~= nil)) then
				k = preferredjailghost()
				if (ghosts[k].dotcount >= ghosts[k].dotlimit) then
					if ((ghosts[k].scattermode % 2) == 0) then
						ghosts[k].mode = 1
					else
						ghosts[k].mode = 0
					end
				end
			elseif ((globaldotcounterenabled == true) and (preferredjailghost() ~= nil)) then
				if ((globaldotcounter == 7) and (isinjailtype(1))) then
					freegtype(1)
				elseif ((globaldotcounter == 17) and (isinjailtype(2))) then
					freegtype(2)
				elseif ((globaldotcounter == 32) and (isinjailtype(3))) then
					freegtype(3)
					globaldotcounterenabled = false
					freedelroy = true
				end
			end

			if ((lasteatendot >= 4000) and (preferredjailghost() ~= nil)) then
				k = preferredjailghost()
				if ((ghosts[k].scattermode % 2) == 0) then
					ghosts[k].mode = 1
				else
					ghosts[k].mode = 0
				end
				lasteatendot = 0
				if ((ghosts[k].gtype == 3) and (freedelroy == false)) then
					freedelroy = true
				end
			end

			for i=1,table.getn(ghosts) do
				if (ghosts[i].mode == 0) then
					if (ghosts[i].scattermode ~= 7) then
						ghosts[i].scattertime = ghosts[i].scattertime + dt * 1000
						if (ghosts[i].scattertime >= 20000) then
							ghosts[i].scattertime = 0
							ghosts[i].scattermode = ghosts[i].scattermode + 1
							ghosts[i].mode = 1
							ghosts[i].direction = reverser(i) --reverse direction
						end
					end
				elseif (ghosts[i].mode == 1) then
					if ((ghosts[i].scattermode == 0) or (ghosts[i].scattermode == 2)) then
						ghosts[i].scattertime = ghosts[i].scattertime + dt * 1000
						if (ghosts[i].scattertime >= 7000) then
							ghosts[i].scattertime = 0
							ghosts[i].scattermode = ghosts[i].scattermode + 1
							ghosts[i].mode = 0
							ghosts[i].direction = reverser(i) --reverse direction
						end
					else
						ghosts[i].scattertime = ghosts[i].scattertime + dt * 1000
						if (ghosts[i].scattertime >= 5000) then
							ghosts[i].scattertime = 0
							ghosts[i].scattermode = ghosts[i].scattermode + 1
							ghosts[i].mode = 0
							ghosts[i].direction = reverser(i) --reverse direction
						end
					end
				elseif (ghosts[i].mode == 2) then
					ghosts[i].frightenedtime = ghosts[i].frightenedtime - dt * 1000
					if (ghosts[i].frightenedtime <= 0) then
						ghosts[i].direction = reverser(i) --reverse direction
						if ((ghosts[i].scattermode % 2) == 0) then
							ghosts[i].mode = 1
						else
							ghosts[i].mode = 0
						end
					end
				end

				if (ghosts[i].stopped == false) then
					if (ghosts[i].direction == 0) then
						gmove(i, dt)
					elseif (ghosts[i].direction == 1) then
						gmove(i, dt)
					elseif (ghosts[i].direction == 2) then
						gmove(i, dt)
					elseif (ghosts[i].direction == 3) then
						gmove(i, dt)
					end
				else
					ghosts[i].lastcheckx = ghosts[i].x
					ghosts[i].lastchecky = ghosts[i].y
					ghosts[i].direction = gpathfinder(mappa, ghosts[i], player, i)
					ghosts[i].stopped = false
				end
				eatpacman(i)
			end
		end
		
	end
	if love.keyboard.isDown("escape") then
	  love.event.push("quit")
	end
	if love.keyboard.isDown("f") then
	  tofrightened()
	end
end

function love.keyreleased( key )
	if ((key == "r") or (key == "a")) then
		--reset
		gameover = false
	end
	if ((key == " ") and (started == false) and (deathtimer <= 0)) then
		started = true
	end
end
function distance(x1, y1, x2, y2)
	return (((x2-x1)*(x2-x1))+((y2-y1)*(y2-y1)))
end
function pathfinder(mappa, direction, x, y, xt, yt, mode)
	if (not((x >= 12) and (x <= 17) and ((y == 15) or (y == 27)) and ((direction % 2) == 1))) then
		if (not((x == gridw) or (x == 1))) then --check per i tunnel
			up = distance(x,y-1,xt,yt)
			left = distance(x-1,y,xt,yt)
			down = distance(x,y+1,xt,yt)
			right = distance(x+1,y,xt,yt)

			doorup = ((mappa[x][y-1] ~= 3) or ((mode == 4) and (not(isincagexy(x, y)))) or ((mode ~= 4) and (isincagexy(x, y))))
			doorleft = ((mappa[x-1][y] ~= 3) or ((mode == 4) and (not(isincagexy(x, y)))) or ((mode ~= 4) and (isincagexy(x, y))))
			doordown = ((mappa[x][y+1] ~= 3) or ((mode == 4) and (not(isincagexy(x, y)))) or ((mode ~= 4) and (isincagexy(x, y))))
			doorright = ((mappa[x+1][y] ~= 3) or ((mode == 4) and (not(isincagexy(x, y)))) or ((mode ~= 4) and (isincagexy(x, y))))

			if((mappa[x][y-1] ~= 1) and doorup and (direction~=2) and ((up<=left) or (mappa[x-1][y] == 1) or (not doorleft) or (direction==3)) and ((up<=right) or (mappa[x+1][y] == 1) or (not doorright) or (direction==1)) and ((up<=down) or (mappa[x][y+1] == 1) or (not doordown) or (direction==0))) then
				direction = 0
			elseif((mappa[x-1][y] ~= 1) and doorleft and (direction~=3) and ((left<=up) or (mappa[x][y-1] == 1) or (not doorup) or (direction==2)) and ((left<=down) or (mappa[x][y+1] == 1) or (not doordown) or (direction==0)) and ((left<=right) or (mappa[x+1][y] == 1) or (not doorright) or (direction==1))) then
				direction = 1
			elseif((mappa[x][y+1] ~= 1) and doordown and (direction~=0) and ((down<=left) or (mappa[x-1][y] == 1) or (not doorleft) or (direction==3)) and ((down<=right) or (mappa[x+1][y] == 1) or (not doorright) or (direction==1)) and ((down<=up) or (mappa[x][y-1] == 1) or (not doorup) or (direction==2))) then
				direction = 2
			elseif ((mappa[x+1][y] ~= 1) and doorright and (direction~=1)) then
				direction = 3
			else
				debugtext = "direction = " .. direction .. "\nmup = " .. mappa[x][y-1] .. "\nmleft = " .. mappa[x-1][y] .. "\nmdown = " .. mappa[x][y+1] .. "\nmright = " .. mappa[x+1][y] .. "\nup = " .. up .. "\nleft = " .. left .. "\ndown = " .. down .. "\nright = " .. right .. "\nx = " .. x .. "\ny = " .. y
				direction = (direction + 2) % 4 --reverse direction
			end
		end
	end
	return direction
end
function gpathfinder(mappa, ghost, player, i)
	if (ghost.mode == 0) then
		if (not(isincage(ghost))) then
			if ((ghost.gtype == 0) or (ghost.gtype == 4) or (ghost.gtype == 5)) then
				direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, player.x, player.y)
			elseif (ghost.gtype == 1) then
				if (player.direction == 0) then
					direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, player.x - 4, player.y - 4, ghost.mode)
				elseif (player.direction == 1) then
					direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, player.x - 4, player.y, ghost.mode)
				elseif (player.direction == 2) then
					direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, player.x, player.y + 4, ghost.mode)
				else
					direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, player.x + 4, player.y, ghost.mode)
				end
			elseif (ghost.gtype == 2) then
				local tx,ty
				if (player.direction == 0) then
					tx = player.x - 2
					ty = player.y - 2
				elseif (player.direction == 1) then
					tx = player.x - 2
					ty = player.y
				elseif (player.direction == 2) then
					tx = player.x
					ty = player.y + 2
				else
					tx = player.x + 2
					ty = player.y
				end
				direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, tx + tx - ghosts[1].x, ty + ty - ghosts[1].y, ghost.mode)
			elseif (ghost.gtype == 3) then
				if (distance(ghost.x, ghost.y, player.x, player.y) >= 64) then
					direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, player.x, player.y, ghost.mode)
				else
					direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, 1, 35, ghost.mode)
				end
			end
		else
			direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, 14, 15, ghost.mode)
		end
	elseif (ghost.mode == 1) then
		if (not(isincage(ghost))) then
			if (not(((ghost.gtype == 4) or (ghost.gtype == 5)) and (freedelroy == true))) then
				direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, ghost.scatterx, ghost.scattery, ghost.mode)
			else
				direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, player.x, player.y)
			end
		else
			direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, 14, 15, ghost.mode)
		end
	elseif (ghost.mode == 2) then
		if (not(isincage(ghost))) then
			direction = rpathfinder(mappa, ghost.direction, ghost.x, ghost.y)
			if (direction == nil) then
				ghosts[i].stopped = true
			end
		else
			direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, 14, 15, ghost.mode)
		end
	elseif (ghost.mode == 3) then
		if (not(isincage(ghost))) then
			if (((ghost.x == 14)) and (ghost.y == 15)) then
				ghosts[i].mode = 4
				direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, 14, 19, ghost.mode)
				if (globaldotcounterenabled == false) then
					ghosts[i].dotcount = 0
				end
			else
				direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, 14, 15, ghost.mode)
			end
		else
			if (ghosts[i].gtype ~= 0) then
				ghosts[i].mode = 4
			else
				if ((ghosts[i].scattermode % 2) == 0) then
					ghosts[i].mode = 1
				else
					ghosts[i].mode = 0
				end
			end
		end
	elseif (ghost.mode == 4) then
		if (isincage(ghost)) then
			direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, math.random(12, 17), math.random(17, 19), ghost.mode)
		elseif (((ghost.x == 14)) and (ghost.y == 15)) then
			direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, 14, 19, ghost.mode)
		else
			direction = pathfinder(mappa, ghost.direction, ghost.x, ghost.y, 14, 15, ghost.mode)
		end
	end
	return direction
end
function gmove(i, dt)
	if (ghosts[i].mode == 2) then
		movement = ((dt/10) * basespeed * 32) * (speeds.frightghost / 100)
	elseif ((ghosts[i].y == 18) and ((ghosts[i].x <= 5) or (ghosts[i].x >= 24))) then
		movement = ((dt/10) * basespeed * 32) * (speeds.ghosttunnel / 100)
	elseif ((ghosts[i].gtype == 4) and (freedelroy == true)) then
		movement = ((dt/10) * basespeed * 32) * (speeds.elroy1 / 100)
	elseif ((ghosts[i].gtype == 5) and (freedelroy == true)) then
		movement = ((dt/10) * basespeed * 32) * (speeds.elroy2 / 100)
	else
		movement = ((dt/10) * basespeed * 32) * (speeds.ghost / 100)
	end

	if (ghosts[i].direction == 0) then
		if (((ghosts[i].partialy >= (32/2)) and ((ghosts[i].partialy - movement) <= (32/2))) and ((ghosts[i].lastcheckx ~= ghosts[i].x) or (ghosts[i].lastchecky ~= ghosts[i].y))) then
			ghosts[i].lastcheckx = ghosts[i].x
			ghosts[i].lastchecky = ghosts[i].y
			ghosts[i].direction = gpathfinder(mappa, ghosts[i], player, i)
		end
		ghosts[i].partialy = ghosts[i].partialy - movement
		if (ghosts[i].partialy <= 0) then
			ghosts[i].y = ghosts[i].y - 1
			ghosts[i].partialy = ghosts[i].partialy + 32
		end
		if (ghosts[i].partialx ~= (32/2)) then
			if (ghosts[i].partialx < (32/2)) then
				ghosts[i].partialx = ghosts[i].partialx + movement
				if (ghosts[i].partialx > (32/2)) then
					ghosts[i].partialx = (32/2)
				end
			else
				ghosts[i].partialx = ghosts[i].partialx - movement
				if (ghosts[i].partialx < (32/2)) then
					ghosts[i].partialx = (32/2)
				end
			end
		end
	elseif (ghosts[i].direction == 1) then
		if (((ghosts[i].partialx >= (32/2)) and ((ghosts[i].partialx - movement) <= (32/2))) and ((ghosts[i].lastcheckx ~= ghosts[i].x) or (ghosts[i].lastchecky ~= ghosts[i].y))) then
			ghosts[i].lastcheckx = ghosts[i].x
			ghosts[i].lastchecky = ghosts[i].y
			ghosts[i].direction = gpathfinder(mappa, ghosts[i], player, i)
		end
		ghosts[i].partialx = ghosts[i].partialx - movement
		if (ghosts[i].partialx <= 0) then
			ghosts[i].x = ghosts[i].x - 1
			if (ghosts[i].x == 0) then
				ghosts[i].x = gridw
			end
			ghosts[i].partialx = ghosts[i].partialx + 32
		end
		if (ghosts[i].partialy ~= (32/2)) then
			if (ghosts[i].partialy < (32/2)) then
				ghosts[i].partialy = ghosts[i].partialy + movement
				if (ghosts[i].partialy > (32/2)) then
					ghosts[i].partialy = (32/2)
				end
			else
				ghosts[i].partialy = ghosts[i].partialy - movement
				if (ghosts[i].partialy < (32/2)) then
					ghosts[i].partialy = (32/2)
				end
			end
		end
	elseif (ghosts[i].direction == 2) then
		if (((ghosts[i].partialy <= (32/2)) and ((ghosts[i].partialy + movement) >= (32/2))) and ((ghosts[i].lastcheckx ~= ghosts[i].x) or (ghosts[i].lastchecky ~= ghosts[i].y))) then
			ghosts[i].lastcheckx = ghosts[i].x
			ghosts[i].lastchecky = ghosts[i].y
			ghosts[i].direction = gpathfinder(mappa, ghosts[i], player, i)
		end
		ghosts[i].partialy = ghosts[i].partialy + movement
		if (ghosts[i].partialy > 32) then
			ghosts[i].y = ghosts[i].y + 1
			ghosts[i].partialy = ghosts[i].partialy - 32
		end
		if (ghosts[i].partialx ~= (32/2)) then
			if (ghosts[i].partialx < (32/2)) then
				ghosts[i].partialx = ghosts[i].partialx + movement
				if (ghosts[i].partialx > (32/2)) then
					ghosts[i].partialx = (32/2)
				end
			else
				ghosts[i].partialx = ghosts[i].partialx - movement
				if (ghosts[i].partialx < (32/2)) then
					ghosts[i].partialx = (32/2)
				end
			end
		end
	elseif (ghosts[i].direction == 3) then
		if (((ghosts[i].partialx <= (32/2)) and ((ghosts[i].partialx + movement) >= (32/2))) and ((ghosts[i].lastcheckx ~= ghosts[i].x) or (ghosts[i].lastchecky ~= ghosts[i].y))) then
			ghosts[i].lastcheckx = ghosts[i].x
			ghosts[i].lastchecky = ghosts[i].y
			ghosts[i].direction = gpathfinder(mappa, ghosts[i], player, i)
		end
		ghosts[i].partialx = ghosts[i].partialx + movement
		if (ghosts[i].partialx > 32) then
			ghosts[i].x = ghosts[i].x + 1
			if (ghosts[i].x == gridw + 1) then
				ghosts[i].x = 1
			end
			ghosts[i].partialx = ghosts[i].partialx - 32
		end
		if (ghosts[i].partialy ~= (32/2)) then
			if (ghosts[i].partialy < (32/2)) then
				ghosts[i].partialy = ghosts[i].partialy + movement
				if (ghosts[i].partialy > (32/2)) then
					ghosts[i].partialy = (32/2)
				end
			else
				ghosts[i].partialy = ghosts[i].partialy - movement
				if (ghosts[i].partialy < (32/2)) then
					ghosts[i].partialy = (32/2)
				end
			end
		end
	end
end

function isincage(ghost)
	return isincagexy(ghost.x, ghost.y)
end

function isincagexy(x, y)
	return (((x >= 11) and (x <= 18)) and ((y >= 16) and (y <= 20)))
end

function rpathfinder(mappa, direction, x, y)
	if (not((x == gridw) or (x == 1))) then --check per i tunnel
		directions = {}
		directions[1] = 0
		directions[2] = 0
		directions[3] = 0
		directions[4] = 0

		if ((mappa[x][y-1] ~= 1) and (mappa[x][y-1] ~= 3) and (direction ~= 2)) then
			directions[1] = 1
		end
		if ((mappa[x-1][y] ~= 1) and (mappa[x-1][y] ~= 3) and (direction ~= 3)) then
			directions[2] = 1
		end
		if ((mappa[x][y+1] ~= 1) and (mappa[x][y+1] ~= 3) and (direction ~= 0)) then
			directions[3] = 1
		end
		if ((mappa[x+1][y] ~= 1) and (mappa[x+1][y] ~= 3) and (direction ~= 1)) then
			directions[4] = 1
		end
		count = 0
		for i=1,table.getn(directions) do
			count = count + directions[i]
		end
		if (count > 0) then
			k = math.random(1,4)
			while (directions[k] == 0) do
				k = (k % 4) + 1
			end
			direction = k - 1
		else
			direction = nil
			debugtext = "direction " .. direction .. "\nup " .. mappa[x][y-1] .. "\nleft " .. mappa[x-1][y] .. "\ndown " .. mappa[x][y+1] .. "\nright " .. mappa[x+1][y] .. "\nx " .. x  .. "\ny " .. y
		end
	end
	return direction
end

function tofrightened()
	if ((ghosts ~= nil) and (table.getn(ghosts) ~= 0)) then
		for i=1,table.getn(ghosts) do
			if ((ghosts[i].mode == 0) or (ghosts[i].mode == 1) or (ghosts[i].mode == 2)) then
				if (ghosts[i].mode ~= 2) then
					ghosts[i].direction = reverser(i) --reverse direction
				end
				ghosts[i].mode = 2
				ghosts[i].frightenedtime = 6000
			end
		end
	end
	player.frightenedtime = 6000
	ghosteatencount = 1
end

function preferredjailghost()
	preferredghost = nil
	if ((ghosts ~= nil) and (table.getn(ghosts) ~= 0)) then
		for i=1,table.getn(ghosts) do
			if ((preferredghost ~= nil) and (ghosts[i].mode == 4) and (ghosts[i].gtype < ghosts[preferredghost].gtype)) then
				preferredghost = i
			elseif ((preferredghost == nil) and (ghosts[i].mode == 4)) then
				preferredghost = i
			end
		end
	end
	return preferredghost
end

function freegtype(gtype)
	if ((ghosts ~= nil) and (table.getn(ghosts) ~= 0)) then
		for i=1,table.getn(ghosts) do
			if ((ghosts[i].gtype == gtype) and (ghosts[i].mode == 4)) then
				if ((ghosts[i].scattermode % 2) == 0) then
					ghosts[i].mode = 1
				else
					ghosts[i].mode = 0
				end
			end
		end
	end
end

function isinjailtype(gtype)
	ritorno = false
	if ((ghosts ~= nil) and (table.getn(ghosts) ~= 0)) then
		for i=1,table.getn(ghosts) do
			if ((ghosts[i].gtype == gtype) and (ghosts[i].mode == 4)) then
				ritorno = true
			end
		end
	end
	return ritorno
end

function eatghosts(x, y)
	--eat ghosts
	if ((ghosts ~= nil) and (table.getn(ghosts) ~= 0)) then
		for i=1,table.getn(ghosts) do
			if ((ghosts[i].x == x) and (ghosts[i].y == y) and (ghosts[i].mode == 2)) then
				score = score + (ghosteatencount * 200)
				ghosteatencount = ghosteatencount * 2
				ghosts[i].mode = 3
			end
		end
	end

	--eatdots and power pellets
	if (mappa[x][y] == 4) then
		mappa[x][y] = 0
		score = score + 10
		dotcounter = dotcounter + 1
		if ((preferredjailghost() ~= nil) and (globaldotcounterenabled == false)) then
			k = preferredjailghost()
			ghosts[k].dotcount = ghosts[k].dotcount + 1
		elseif ((globaldotcounterenabled == true) and (preferredjailghost() ~= nil)) then
			globaldotcounter = globaldotcounter + 1
		end
		lasteatendot = 0
		if ((dotcounter == 70) or (dotcounter == 170)) then
			fruittimer = math.random(9000,10000)
		end
		player.lasteatendotx = x
		player.lasteatendoty = y
	elseif (mappa[x][y] == 5) then
		mappa[x][y] = 0
		score = score + 50
		dotcounter = dotcounter + 1
		tofrightened()
		lasteatendot = 0
		if ((dotcounter == 70) or (dotcounter == 170)) then
			fruittimer = math.random(9000,10000)
		end
		player.lasteatendotx = x
		player.lasteatendoty = y
	end
	if (dotcounter == 224) then
		ghosts[1].gtype = 4
	elseif (dotcounter == 234) then
		ghosts[1].gtype = 5
	end

	--eat fruits
	if ((fruittimer > 0) and (y == 21) and ((x == 14) or (x == 15))) then
		fruittimer = 0
		score = score + 100
		fruitcount = fruitcount + 1
	end
end

function reverser(i)
	direction = ghosts[i].direction

	direction = (ghosts[i].direction + 2) % 4 --reverse direction
	ghosts[i].lastcheckx = 0
	ghosts[i].lastchecky = 0
	return direction
end

function eatpacman(i)

	x = ghosts[i].x
	y = ghosts[i].y

	if ((player.x == x) and (player.y == y) and (ghosts[i].mode ~= 2) and (ghosts[i].mode ~= 3) and (ghosts[i].mode ~= 4)) then
		loselife()
	elseif ((player.x == x) and (player.y == y) and (ghosts[i].mode == 2)) then
		score = score + (ghosteatencount * 200)
		ghosteatencount = ghosteatencount * 2
		ghosts[i].mode = 3
	end
end

function loselife()
	player.lives = player.lives - 1

	if ((ghosts[1].gtype == 4) or (ghosts[1].gtype == 5)) then
		freedelroy = false
	end

	if (player.lives <= 0) then
		gameover = true
	else
		started = false
		deathtimer = 3000
		globaldotcounter = 0
		globaldotcounterenabled = true
	end
end

function reposition()
	player.x = player.startx
	player.y = player.starty
	player.direction = player.startdirection
	player.partialx = player.startpartialx
	player.partialy = player.startpartialy
	player.stopped = true

	if ((ghosts ~= nil) and (table.getn(ghosts) ~= 0)) then
		for i=1,table.getn(ghosts) do
			ghosts[i].x = ghosts[i].startx
			ghosts[i].y = ghosts[i].starty
			ghosts[i].mode = ghosts[i].startmode
			ghosts[i].direction = ghosts[i].startdirection
			ghosts[i].partialx = ghosts[i].startpartialx
			ghosts[i].partialy = ghosts[i].startpartialy
			ghosts[i].scattertime = 0
			ghosts[i].scattermode = 0
		end
	end
end